unit Unit19;

interface

uses
 Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
 Dialogs, ExtCtrls,
 Direct3D9,
 DXUT,
 ParallaxOcclusionMappingUnit, AppEvnts;

type
 TForm19 = class(TForm)
  Panel1: TPanel;
  ApplicationEvents1: TApplicationEvents;
  procedure ApplicationEvents1Idle(Sender: TObject; var Done: boolean);
  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: boolean);
 private
  { Private declarations }
 public
  { Public declarations }
 end;

var
 Form19: TForm19;

implementation

{$R *.dfm}

procedure TForm19.ApplicationEvents1Idle(Sender: TObject; var Done: boolean);
begin
 DXUTRender3DEnvironment;
end;

procedure TForm19.ApplicationEvents1Message(var Msg: tagMSG; var Handled: boolean);
begin
 DXUTStaticWndProc(Handle, Msg.message, Msg.wParam, Msg.lParam);
 Handled := False;
end;

procedure TForm19.FormCreate(Sender: TObject);
begin
 CreateCustomDXUTobjects;
 // Set the callback functions. These functions allow DXUT to notify
 // the application about device changes, user input, and windows messages.  The
 // callbacks are optional so you need only set callbacks for events you're interested
 // in. However, if you don't handle the device reset/lost callbacks then the sample
 // framework won't be able to reset your device since the application must first
 // release all device resources before resetting.  Likewise, if you don't handle the
 // device created/destroyed callbacks then DXUT won't be able to
 // recreate your device resources.
 DXUTSetCallbackDeviceCreated(OnCreateDevice);
 DXUTSetCallbackDeviceReset(OnResetDevice);
 DXUTSetCallbackDeviceLost(OnLostDevice);
 DXUTSetCallbackDeviceDestroyed(OnDestroyDevice);
 DXUTSetCallbackMsgProc(MsgProc);
 DXUTSetCallbackKeyboard(KeyboardProc);
 DXUTSetCallbackFrameRender(OnFrameRender);
 DXUTSetCallbackFrameMove(OnFrameMove);
 // Show the cursor and clip it when in full screen
 DXUTSetCursorSettings(True, True);
 InitApp;
 // Initialize DXUT and create the desired Win32 window and Direct3D
 // device for the application. Calling each of these functions is optional, but they
 // allow you to set several options which control the behavior of the framework.
 DXUTInit(True, True, True); // Parse the command line, handle the default hotkeys, and show msgboxes
 DXUTSetWindow(Panel1.Handle, Panel1.Handle, Panel1.Handle, False);
 //DXUTCreateWindow('Parallax Occlusion Mapping');
 DXUTCreateDevice(D3DADAPTER_DEFAULT, True, 0, 0, IsDeviceAcceptable, ModifyDeviceSettings);
end;

procedure TForm19.FormDestroy(Sender: TObject);
begin
 // Perform any application-level cleanup here. Direct3D device resources are released within the
 // appropriate callback functions and therefore don't require any cleanup code here.
 ExitCode := DXUTGetExitCode;
 DXUTFreeState;
 DestroyCustomDXUTobjects;
end;

end.
